#subruledef operand
{
    #{immediate: s5} => 0b000 @ immediate
    r{register: u5} => 0b001 @ register
    [r{register: u5}++] => 0b010 @ register
    [r{register: u5}--] => 0b011 @ register
    [r{register: u5}] => 0b100 @ register
    [r{register: u5} + {offset: u2} => 0b1 @ offset @ register
}

#subruledef crflags
{
    .    => 0b0000
    .l   => 0b0010
    .le  => 0b0100
    .e   => 0b0110
    .ge  => 0b1000
    .g   => 0b1010
    .ne  => 0b1100
    .r   => 0b0001
    .rl  => 0b0011
    .rle => 0b0101
    .re  => 0b0111
    .rge => 0b1001
    .re  => 0b1011
    .rne => 0b1101
}

#ruledef
{
    CNST{flags: crflags} {dst: operand}, {imm: i16} => imm @ 0b0000 @ flags @ dst
}

#bankdef mem
{
    #bits 16
    #addr 0
    #size 0x10000
    #outp 0
}

#bank mem
