mod vm;

use vm::{FootVM};

fn main()
{
    let mut vm = FootVM::new();
    vm[0] = 0xFEED;
    vm[1] = 0b0000_0000_001_00000;

    let result = vm.load("CNST. r0, 0xBEEF", Some(&mut std::io::stderr()));
    if result.is_ok()
    {
        vm.cycle();

        println!("{}", vm.registers[0]);
    }
}
